Whamcloud - gitweb
LU-10934 llite: integrate statx() API with Lustre
[fs/lustre-release.git] / lustre / tests / sanity.sh
index 9fa70ee..513ecae 100755 (executable)
@@ -1635,6 +1635,28 @@ test_27ce() {
 }
 run_test 27ce "more stripes than OSTs with -o"
 
+test_27cf() {
+       local osp_proc="osp.$FSNAME-OST0000-osc-MDT000*.active"
+       local pid=0
+
+       test_mkdir -p $DIR/$tdir || error "failed to mkdir $DIR/$tdir"
+       do_facet $SINGLEMDS "$LCTL set_param -n $osp_proc=0"
+       stack_trap "do_facet $SINGLEMDS $LCTL set_param -n $osp_proc=1" EXIT
+       wait_update_facet $SINGLEMDS "$LCTL get_param -n $osp_proc | grep 1" ||
+               error "failed to set $osp_proc=0"
+
+       $LFS setstripe -o 0 $DIR/$tdir/$tfile &
+       pid=$!
+       sleep 1
+       do_facet $SINGLEMDS "$LCTL set_param -n $osp_proc=1"
+       wait_update_facet $SINGLEMDS "$LCTL get_param -n $osp_proc | grep 0" ||
+               error "failed to set $osp_proc=1"
+       wait $pid
+       [[ $pid -ne 0 ]] ||
+               error "should return error due to $osp_proc=0"
+}
+run_test 27cf "'setstripe -o' on inactive OSTs should return error"
+
 test_27d() {
        test_mkdir $DIR/$tdir
        $LFS setstripe -c 0 -i -1 -S 0 $DIR/$tdir/$tfile ||
@@ -3053,7 +3075,7 @@ run_test 30b "execute binary from Lustre as non-root ==========="
 test_30c() { # b=22376
        [ $PARALLEL == "yes" ] && skip "skip parallel run"
 
-       cp `which ls` $DIR || cp /bin/ls $DIR
+       cp $(which ls) $DIR || cp /bin/ls $DIR
        chmod a-rw $DIR/ls
        cancel_lru_locks mdc
        cancel_lru_locks osc
@@ -3062,6 +3084,22 @@ test_30c() { # b=22376
 }
 run_test 30c "execute binary from Lustre without read perms ===="
 
+test_30d() {
+       cp $(which dd) $DIR || error "failed to copy dd to $DIR/dd"
+
+       for i in {1..10}; do
+               $DIR/dd bs=1M count=128 if=/dev/zero of=$DIR/$tfile &
+               local PID=$!
+               sleep 1
+               $LCTL set_param ldlm.namespaces.*MDT*.lru_size=clear
+               wait $PID || error "executing dd from Lustre failed"
+               rm -f $DIR/$tfile
+       done
+
+       rm -f $DIR/dd
+}
+run_test 30d "execute binary from Lustre while clear locks"
+
 test_31a() {
        $OPENUNLINK $DIR/f31 $DIR/f31 || error "openunlink failed"
        $CHECKSTAT -a $DIR/f31 || error "$DIR/f31 exists"
@@ -5586,16 +5624,24 @@ test_56c() {
        local ost_idx=0
        local ost_name=$(ostname_from_index $ost_idx)
        local old_status=$(ost_dev_status $ost_idx)
+       local p="$TMP/$TESTSUITE-$TESTNAME.parameters"
 
        [[ -z "$old_status" ]] ||
                skip_env "OST $ost_name is in $old_status status"
 
        do_facet ost1 $LCTL set_param -n obdfilter.$ost_name.degraded=1
-       [[ $OST1_VERSION -ge $(version_code 2.12.55) ]] && do_facet ost1 \
+       [[ $OST1_VERSION -lt $(version_code 2.12.55) ]] || do_facet ost1 \
                $LCTL set_param -n obdfilter.$ost_name.no_precreate=1
+       if [[ $OST1_VERSION -ge $(version_code 2.12.57) ]]; then
+               save_lustre_params ost1 osd-*.$ost_name.nonrotational > $p
+               do_facet ost1 $LCTL set_param -n osd-*.$ost_name.nonrotational=1
+       fi
+
+       [[ $($LFS df -v $MOUNT |& grep -c "inactive device") -eq 0 ]] ||
+               error "$LFS df -v showing inactive devices"
        sleep_maxage
 
-       local new_status=$(ost_dev_status $ost_idx)
+       local new_status=$(ost_dev_status $ost_idx $MOUNT -v)
 
        [[ "$new_status" =~ "D" ]] ||
                error "$ost_name status is '$new_status', missing 'D'"
@@ -5603,18 +5649,37 @@ test_56c() {
                [[ "$new_status" =~ "N" ]] ||
                        error "$ost_name status is '$new_status', missing 'N'"
        fi
+       if [[ $OST1_VERSION -ge $(version_code 2.12.57) ]]; then
+               [[ "$new_status" =~ "f" ]] ||
+                       error "$ost_name status is '$new_status', missing 'f'"
+       fi
 
        do_facet ost1 $LCTL set_param -n obdfilter.$ost_name.degraded=0
-       [[ $OST1_VERSION -ge $(version_code 2.12.55) ]] && do_facet ost1 \
+       [[ $OST1_VERSION -lt $(version_code 2.12.55) ]] || do_facet ost1 \
                $LCTL set_param -n obdfilter.$ost_name.no_precreate=0
+       [[ -z "$p" ]] && restore_lustre_params < $p || true
        sleep_maxage
 
        new_status=$(ost_dev_status $ost_idx)
        [[ ! "$new_status" =~ "D" && ! "$new_status" =~ "N" ]] ||
                error "$ost_name status is '$new_status', has 'D' and/or 'N'"
+       # can't check 'f' as devices may actually be on flash
 }
 run_test 56c "check 'lfs df' showing device status"
 
+test_56d() {
+       local mdts=$($LFS df -v $MOUNT | grep -c MDT)
+       local osts=$($LFS df -v $MOUNT | grep -c OST)
+
+       $LFS df $MOUNT
+
+       (( mdts == MDSCOUNT )) ||
+               error "lfs df -v showed $mdts MDTs, not $MDSCOUNT"
+       (( osts == OSTCOUNT )) ||
+               error "lfs df -v showed $osts OSTs, not $OSTCOUNT"
+}
+run_test 56d "'lfs df -v' prints only configured devices"
+
 NUMFILES=3
 NUMDIRS=3
 setup_56() {
@@ -5842,18 +5907,26 @@ test_newerXY_base() {
        local negref
 
        if [ $y == "t" ]; then
-               ref="\"$(date +"%Y-%m-%d %H:%M:%S")\""
+               if [ $x == "b" ]; then
+                       ref="\"$(do_facet mds1 date +"%Y-%m-%d\ %H:%M:%S")\""
+               else
+                       ref="\"$(date +"%Y-%m-%d %H:%M:%S")\""
+               fi
        else
-               ref=$DIR/$tfile.newer
+               ref=$DIR/$tfile.newer.$x$y
                touch $ref || error "touch $ref failed"
        fi
        sleep 2
        setup_56 $dir $NUMFILES $NUMDIRS "-i0 -c1" "-i0 -c1"
        sleep 2
        if [ $y == "t" ]; then
-               negref="\"$(date +"%Y-%m-%d %H:%M:%S")\""
+               if [ $x == "b" ]; then
+                       negref="\"$(do_facet mds1 date +"%Y-%m-%d\ %H:%M:%S")\""
+               else
+                       negref="\"$(date +"%Y-%m-%d %H:%M:%S")\""
+               fi
        else
-               negref=$DIR/$tfile.newerneg
+               negref=$DIR/$tfile.negnewer.$x$y
                touch $negref || error "touch $negref failed"
        fi
 
@@ -5878,6 +5951,7 @@ test_newerXY_base() {
 }
 
 test_56oc() {
+       test_newerXY_base "b" "t"
        test_newerXY_base "a" "a"
        test_newerXY_base "a" "m"
        test_newerXY_base "a" "c"
@@ -5887,12 +5961,96 @@ test_56oc() {
        test_newerXY_base "c" "a"
        test_newerXY_base "c" "m"
        test_newerXY_base "c" "c"
+       test_newerXY_base "b" "b"
        test_newerXY_base "a" "t"
        test_newerXY_base "m" "t"
        test_newerXY_base "c" "t"
+       test_newerXY_base "b" "t"
 }
 run_test 56oc "check lfs find -newerXY work"
 
+btime_supported() {
+       local dir=$DIR/$tdir
+       local rc
+
+       mkdir -p $dir
+       touch $dir/$tfile
+       $LFS find $dir -btime -1d -type f
+       rc=$?
+       rm -rf $dir
+       return $rc
+}
+
+test_56od() {
+       [ $MDS1_VERSION -lt $(version_code 2.13.53) ] &&
+               ! btime_supported && skip "btime unsupported on MDS"
+
+       [ $CLIENT_VERSION -lt $(version_code 2.13.53) ] &&
+               ! btime_supported && skip "btime unsupported on clients"
+
+       local dir=$DIR/$tdir
+       local ref=$DIR/$tfile.ref
+       local negref=$DIR/$tfile.negref
+
+       mkdir $dir || error "mkdir $dir failed"
+       touch $dir/$tfile.n1 || error "touch $dir/$tfile.n1 failed"
+       touch $dir/$tfile.n2 || error "touch $dir/$tfile.n2 failed"
+       mkdir $dir/$tdir.n1 || error "mkdir $dir/$tdir.n1 failed"
+       mkdir $dir/$tdir.n2 || error "mkdir $dir/$tdir.n2 failed"
+       touch $ref || error "touch $ref failed"
+       # sleep 3 seconds at least
+       sleep 3
+
+       local before=$(do_facet mds1 date +%s)
+       local skew=$(($(date +%s) - before + 1))
+
+       if (( skew < 0 && skew > -5 )); then
+               sleep $((0 - skew + 1))
+               skew=0
+       fi
+
+       # Set the dir stripe params to limit files all on MDT0,
+       # otherwise we need to calc the max clock skew between
+       # the client and MDTs.
+       setup_56 $dir/d.btime $NUMFILES $NUMDIRS "-i0 -c1" "-i0 -c1"
+       sleep 2
+       touch $negref || error "touch $negref failed"
+
+       local cmd="$LFS find $dir -newerbb $ref ! -newerbb $negref -type f"
+       local nums=$($cmd | wc -l)
+       local expected=$(((NUMFILES + 1) * NUMDIRS))
+
+       [ $nums -eq $expected ] ||
+               error "'$cmd' wrong: found $nums, expected $expected"
+
+       cmd="$LFS find $dir -newerbb $ref ! -newerbb $negref -type d"
+       nums=$($cmd | wc -l)
+       expected=$((NUMFILES + 1))
+       [ $nums -eq $expected ] ||
+               error "'$cmd' wrong: found $nums, expected $expected"
+
+       [ $skew -lt 0 ] && return
+
+       local after=$(do_facet mds1 date +%s)
+       local age=$((after - before + 1 + skew))
+
+       cmd="$LFS find $dir -btime -${age}s -type f"
+       nums=$($cmd | wc -l)
+       expected=$(((NUMFILES + 1) * NUMDIRS))
+
+       echo "Clock skew between client and server: $skew, age:$age"
+       [ $nums -eq $expected ] ||
+               error "'$cmd' wrong: found $nums, expected $expected"
+
+       expected=$(($NUMDIRS + 1))
+       cmd="$LFS find $dir -btime -${age}s -type d"
+       nums=$($cmd | wc -l)
+       [ $nums -eq $expected ] ||
+               error "'$cmd' wrong: found $nums, expected $expected"
+       rm -f $ref $negref || error "Failed to remove $ref $negref"
+}
+run_test 56od "check lfs find -btime with units"
+
 test_56p() {
        [ $RUNAS_ID -eq $UID ] &&
                skip_env "RUNAS_ID = UID = $UID -- skipping"
@@ -6021,156 +6179,89 @@ test_56r() {
 }
 run_test 56r "check lfs find -size works"
 
-test_56ra() {
-       [[ $MDS1_VERSION -gt $(version_code 2.12.58) ]] ||
-               skip "MDS < 2.12.58 doesn't return LSOM data"
-       local dir=$DIR/$tdir
-
-       [[ $OSC == "mdc" ]] && skip "DoM files" && return
-
-       setup_56 $dir $NUMFILES $NUMDIRS "-c 1"
+test_56ra_sub() {
+       local expected=$1
+       local glimpses=$2
+       local cmd="$3"
 
        cancel_lru_locks $OSC
 
        local rpcs_before=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       local expected=12
-       local cmd="$LFS find -size 0 -type f -lazy $dir"
        local nums=$($cmd | wc -l)
 
        [ $nums -eq $expected ] ||
                error "'$cmd' wrong: found $nums, expected $expected"
 
        local rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       [ $rpcs_before -eq $rpcs_after ] ||
-               error "'$cmd' should not send glimpse RPCs to OST"
-       cmd="$LFS find -size 0 -type f $dir"
-       nums=$($cmd | wc -l)
-       [ $nums -eq $expected ] ||
-               error "'$cmd' wrong: found $nums, expected $expected"
-       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       echo "Before: $rpcs_before After: $rpcs_after $NUMFILES"
-       $LCTL get_param osc.*.stats
-       [ $rpcs_after -eq $((rpcs_before + 12)) ] ||
-               error "'$cmd' should send 12 glimpse RPCs to OST"
 
+       if (( rpcs_before + glimpses != rpcs_after )); then
+               echo "Before: $rpcs_before After: $rpcs_after $NUMFILES"
+               $LCTL get_param osc.*.stats | grep ldlm_glimpse_enqueue
+
+               if [[ $glimpses == 0 ]]; then
+                       error "'$cmd' should not send glimpse RPCs to OST"
+               else
+                       error "'$cmd' should send $glimpses glimpse RPCs to OST"
+               fi
+       fi
+}
+
+test_56ra() {
+       [[ $MDS1_VERSION -gt $(version_code 2.12.58) ]] ||
+               skip "MDS < 2.12.58 doesn't return LSOM data"
+       local dir=$DIR/$tdir
+
+       [[ $OSC == "mdc" ]] && skip "DoM files" && return
+
+       setup_56 $dir $NUMFILES $NUMDIRS "-c 1"
+       # open and close all files to ensure LSOM is updated
        cancel_lru_locks $OSC
-       rpcs_before=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       expected=0
-       cmd="$LFS find ! -size 0 -type f -lazy $dir"
-       nums=$($cmd | wc -l)
-       [ $nums -eq $expected ] ||
-               error "'$cmd' wrong: found $nums, expected $expected"
-       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       $LCTL get_param mdc.*.stats
-       [ $rpcs_before -eq $rpcs_after ] ||
-               error "'$cmd' should not send glimpse RPCs to OST"
-       cmd="$LFS find ! -size 0 -type f $dir"
-       nums=$($cmd | wc -l)
-       [ $nums -eq $expected ] ||
-               error "'$cmd' wrong: found $nums, expected $expected"
-       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       echo "Before: $rpcs_before After: $rpcs_after $NUMFILES"
-       [ $rpcs_after -eq $((rpcs_before + 12)) ] ||
-               error "'$cmd' should send 12 glimpse RPCs to OST"
+       find $dir -type f | xargs cat > /dev/null
+
+       #   expect_found  glimpse_rpcs  command_to_run
+       test_56ra_sub 12  0 "$LFS find -size 0 -type f -lazy $dir"
+       test_56ra_sub 12 12 "$LFS find -size 0 -type f $dir"
+       test_56ra_sub  0  0 "$LFS find ! -size 0 -type f -lazy $dir"
+       test_56ra_sub  0 12 "$LFS find ! -size 0 -type f $dir"
 
        echo "test" > $dir/$tfile
        echo "test2" > $dir/$tfile.2 && sync
        cancel_lru_locks $OSC
-       rpcs_before=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       expected=1
-       cmd="$LFS find -size 5 -type f -lazy $dir"
-       nums=$($cmd | wc -l)
-       [ $nums -eq $expected ] ||
-               error "'$cmd' wrong: found $nums, expected $expected"
-       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       [ $rpcs_before -eq $rpcs_after ] ||
-               error "'$cmd' should not send glimpse RPCs to OST"
-       cmd="$LFS find -size 5 -type f $dir"
-       nums=$($cmd | wc -l)
-       [ $nums -eq $expected ] ||
-               error "'$cmd' wrong: found $nums, expected $expected"
-       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       echo "Before: $rpcs_before After: $rpcs_after $NUMFILES"
-       [ $rpcs_after -eq $((rpcs_before + 14)) ] ||
-               error "'$cmd' should send 14 glimpse RPCs to OST"
+       cat $dir/$tfile $dir/$tfile.2 > /dev/null
 
-       cancel_lru_locks $OSC
-       rpcs_before=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       expected=1
-       cmd="$LFS find -size +5 -type f -lazy $dir"
-       nums=$($cmd | wc -l)
-       [ $nums -eq $expected ] ||
-               error "'$cmd' wrong: found $nums, expected $expected"
-       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       [ $rpcs_before -eq $rpcs_after ] ||
-               error "'$cmd' should not send glimpse RPCs to OST"
-       cmd="$LFS find -size +5 -type f $dir"
-       nums=$($cmd | wc -l)
-       [ $nums -eq $expected ] ||
-               error "'$cmd' wrong: found $nums, expected $expected"
-       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       echo "Before: $rpcs_before After: $rpcs_after $NUMFILES"
-       [ $rpcs_after -eq $((rpcs_before + 14)) ] ||
-               error "'$cmd' should send 14 glimpse RPCs to OST"
+       test_56ra_sub  1  0 "$LFS find -size 5 -type f -lazy $dir"
+       test_56ra_sub  1 14 "$LFS find -size 5 -type f $dir"
+       test_56ra_sub  1  0 "$LFS find -size +5 -type f -lazy $dir"
+       test_56ra_sub  1 14 "$LFS find -size +5 -type f $dir"
 
-       cancel_lru_locks $OSC
-       rpcs_before=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       expected=2
-       cmd="$LFS find -size +0 -type f -lazy $dir"
-       nums=$($cmd | wc -l)
-       [ $nums -eq $expected ] ||
-               error "'$cmd' wrong: found $nums, expected $expected"
-       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       [ $rpcs_before -eq $rpcs_after ] ||
-               error "'$cmd' should not send glimpse RPCs to OST"
-       cmd="$LFS find -size +0 -type f $dir"
-       nums=$($cmd | wc -l)
-       [ $nums -eq $expected ] ||
-               error "'$cmd' wrong: found $nums, expected $expected"
-       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       echo "Before: $rpcs_before After: $rpcs_after $NUMFILES"
-       [ $rpcs_after -eq $((rpcs_before + 14)) ] ||
-               error "'$cmd' should send 14 glimpse RPCs to OST"
+       test_56ra_sub  2  0 "$LFS find -size +0 -type f -lazy $dir"
+       test_56ra_sub  2 14 "$LFS find -size +0 -type f $dir"
+       test_56ra_sub  2  0 "$LFS find ! -size -5 -type f -lazy $dir"
+       test_56ra_sub  2 14 "$LFS find ! -size -5 -type f $dir"
+       test_56ra_sub 12  0 "$LFS find -size -5 -type f -lazy $dir"
+       test_56ra_sub 12 14 "$LFS find -size -5 -type f $dir"
+}
+run_test 56ra "check lfs find -size -lazy works for data on OSTs"
 
-       cancel_lru_locks $OSC
-       rpcs_before=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       expected=2
-       cmd="$LFS find ! -size -5 -type f -lazy $dir"
-       nums=$($cmd | wc -l)
-       [ $nums -eq $expected ] ||
-               error "'$cmd' wrong: found $nums, expected $expected"
-       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       [ $rpcs_before -eq $rpcs_after ] ||
-               error "'$cmd' should not send glimpse RPCs to OST"
-       cmd="$LFS find ! -size -5 -type f $dir"
-       nums=$($cmd | wc -l)
-       [ $nums -eq $expected ] ||
-               error "'$cmd' wrong: found $nums, expected $expected"
-       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       echo "Before: $rpcs_before After: $rpcs_after $NUMFILES"
-       [ $rpcs_after -eq $((rpcs_before + 14)) ] ||
-               error "'$cmd' should send 14 glimpse RPCs to OST"
+test_56rb() {
+       local dir=$DIR/$tdir
+       local tmp=$TMP/$tfile.log
+       local mdt_idx;
 
-       cancel_lru_locks $OSC
-       rpcs_before=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       expected=12
-       cmd="$LFS find -size -5 -type f -lazy $dir"
-       nums=$($cmd | wc -l)
-       [ $nums -eq $expected ] ||
-               error "'$cmd' wrong: found $nums, expected $expected"
-       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       [ $rpcs_before -eq $rpcs_after ] ||
-               error "'$cmd' should not send glimpse RPCs to OST"
-       cmd="$LFS find -size -5 -type f $dir"
-       nums=$($cmd | wc -l)
-       [ $nums -eq $expected ] ||
-               error "'$cmd' wrong: found $nums, expected $expected"
-       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       echo "Before: $rpcs_before After: $rpcs_after $NUMFILES"
-       [ $rpcs_after -eq $((rpcs_before + 14)) ] ||
-               error "'$cmd' should send 14 glimpse RPCs to OST"
+       test_mkdir -p $dir || error "failed to mkdir $dir"
+       $LFS setstripe -c 1 -i 0 $dir/$tfile ||
+               error "failed to setstripe $dir/$tfile"
+       dd if=/dev/zero of=$dir/$tfile bs=1M count=1
+
+       stack_trap "rm -f $tmp" EXIT
+       $LFS find --size +100K --ost 0 $dir 2>&1 | tee $tmp
+       [ -z "$(cat $tmp | grep "obd_uuid: ")" ] ||
+               error "failed to find --size +100K --ost 0 $dir"
+       $LFS find --size +100K --mdt $mdt_idx $dir 2>&1 | tee $tmp
+       [ -z "$(cat $tmp | grep "obd_uuid: ")" ] ||
+               error "failed to find --size +100K --mdt $mdt_idx $dir"
 }
-run_test 56ra "check lfs find -size -lazy works for data on OSTs"
+run_test 56rb "check lfs find --size --ost/--mdt works"
 
 test_56s() { # LU-611 #LU-9369
        [[ $OSTCOUNT -lt 2 ]] && skip_env "need at least 2 OSTs"
@@ -6997,6 +7088,46 @@ test_56xe() {
 }
 run_test 56xe "migrate a composite layout file"
 
+test_56xf() {
+       [[ $OSTCOUNT -ge 2 ]] || skip_env "needs >= 2 OSTs"
+
+       [[ $MDS1_VERSION -ge $(version_code 2.13.53) ]] ||
+               skip "Need server version at least 2.13.53"
+
+       local dir=$DIR/$tdir
+       local f_comp=$dir/$tfile
+       local layout="-E 1M -c1 -E -1 -c2"
+       local fid_before=""
+       local fid_after=""
+
+       test_mkdir "$dir" || error "cannot create dir $dir"
+       $LFS setstripe $layout $f_comp ||
+               error "cannot setstripe $f_comp with layout $layout"
+       fid_before=$($LFS getstripe --fid $f_comp)
+       dd if=/dev/zero of=$f_comp bs=1M count=4
+
+       # 1. migrate a comp layout file to a comp layout
+       $LFS migrate $f_comp || error "cannot migrate $f_comp by lfs migrate"
+       fid_after=$($LFS getstripe --fid $f_comp)
+       [ "$fid_before" == "$fid_after" ] ||
+               error "comp-to-comp migrate: $fid_before != $fid_after"
+
+       # 2. migrate a comp layout file to a plain layout
+       $LFS migrate -c2 $f_comp ||
+               error "cannot migrate $f_comp by lfs migrate"
+       fid_after=$($LFS getstripe --fid $f_comp)
+       [ "$fid_before" == "$fid_after" ] ||
+               error "comp-to-plain migrate: $fid_before != $fid_after"
+
+       # 3. migrate a plain layout file to a comp layout
+       $LFS migrate $layout $f_comp ||
+               error "cannot migrate $f_comp by lfs migrate"
+       fid_after=$($LFS getstripe --fid $f_comp)
+       [ "$fid_before" == "$fid_after" ] ||
+               error "plain-to-comp migrate: $fid_before != $fid_after"
+}
+run_test 56xf "FID is not lost during migration of a composite layout file"
+
 test_56y() {
        [ $MDS1_VERSION -lt $(version_code 2.4.53) ] &&
                skip "No HSM $(lustre_build_version $SINGLEMDS) MDS < 2.4.53"
@@ -9119,17 +9250,21 @@ test_101d() {
        stack_trap "$LCTL set_param -n llite.*.max_read_ahead_mb $old_RA" EXIT
        $LCTL get_param -n llite.*.max_read_ahead_mb
 
-       echo Reading the test file $file with read-ahead disabled
+       echo "Reading the test file $file with read-ahead disabled"
        local sz_KB=$((sz_MB * 1024 / 4))
-       local raOFF=$(do_and_time "dd if=$file of=/dev/null bs=4k count=$sz_KB")
+       # 10485760 bytes transferred in 0.000938 secs (11179579337 bytes/sec)
+       # 104857600 bytes (105 MB) copied, 0.00876352 s, 12.0 GB/s
+       local raOFF=$(LANG=C dd if=$file of=/dev/null bs=4k count=$sz_KB |&
+                     sed -e '/records/d' -e 's/.* \([0-9]*\.[0-9]*\) *s.*/\1/')
 
-       echo Cancel LRU locks on lustre client to flush the client cache
+       echo "Cancel LRU locks on lustre client to flush the client cache"
        cancel_lru_locks osc
        echo Enable read-ahead with ${ra_MB}MB
        $LCTL set_param -n llite.*.max_read_ahead_mb=$ra_MB
 
-       echo Reading the test file $file with read-ahead enabled
-       local raON=$(do_and_time "dd if=$file of=/dev/null bs=4k count=$sz_KB")
+       echo "Reading the test file $file with read-ahead enabled"
+       local raON=$(LANG=C dd if=$file of=/dev/null bs=4k count=$sz_KB |&
+                    sed -e '/records/d' -e 's/.* \([0-9]*\.[0-9]*\) *s.*/\1/')
 
        echo "read-ahead disabled time read $raOFF"
        echo "read-ahead enabled time read $raON"
@@ -9137,7 +9272,8 @@ test_101d() {
        rm -f $file
        wait_delete_completed
 
-       [ $raOFF -le 1 ] || [ $raON -lt $raOFF ] ||
+       # use awk for this check instead of bash because it handles decimals
+       awk "{ exit !($raOFF < 1.0 || $raOFF > $raON) }" <<<"ignore_me" ||
                error "readahead ${raON}s > no-readahead ${raOFF}s ${sz_MB}M"
 }
 run_test 101d "file read with and without read-ahead enabled"
@@ -9462,36 +9598,54 @@ test_102a() {
 }
 run_test 102a "user xattr test =================================="
 
+check_102b_layout() {
+       local layout="$*"
+       local testfile=$DIR/$tfile
+
+       echo "test layout '$layout'"
+       $LFS setstripe $layout $testfile || error "setstripe failed"
+       $LFS getstripe -y $testfile
+
+       echo "get/set/list trusted.lov xattr ..." # b=10930
+       local value=$(getfattr -n trusted.lov -e hex $testfile | grep trusted)
+       [[ "$value" =~ "trusted.lov" ]] ||
+               error "can't get trusted.lov from $testfile"
+       local stripe_count_orig=$($LFS getstripe -c $testfile) ||
+               error "getstripe failed"
+
+       $MCREATE $testfile.2 || error "mcreate $testfile.2 failed"
+
+       value=$(cut -d= -f2 <<<$value)
+       # LU-13168: truncated xattr should fail if short lov_user_md header
+       [ $CLIENT_VERSION -lt $(version_code 2.13.53) ] &&
+               lens="${#value}" || lens="$(seq 4 2 ${#value})"
+       for len in $lens; do
+               echo "setfattr $len $testfile.2"
+               setfattr -n trusted.lov -v ${value:0:$len} $testfile.2 &&
+                       [ $len -lt 66 ] && error "short xattr len=$len worked"
+       done
+       local stripe_size=$($LFS getstripe -S $testfile.2)
+       local stripe_count=$($LFS getstripe -c $testfile.2)
+       [[ $stripe_size -eq 65536 ]] ||
+               error "stripe size $stripe_size != 65536"
+       [[ $stripe_count -eq $stripe_count_orig ]] ||
+               error "stripe count $stripe_count != $stripe_count_orig"
+       rm $testfile $testfile.2
+}
+
 test_102b() {
        [ -z "$(which setfattr 2>/dev/null)" ] &&
                skip_env "could not find setfattr"
        [[ $OSTCOUNT -lt 2 ]] && skip_env "needs >= 2 OSTs"
 
-       # b10930: get/set/list trusted.lov xattr
-       echo "get/set/list trusted.lov xattr ..."
-       local testfile=$DIR/$tfile
-       $LFS setstripe -S 65536 -i 1 -c $OSTCOUNT $testfile ||
-               error "setstripe failed"
-       local STRIPECOUNT=$($LFS getstripe -c $testfile) ||
-               error "getstripe failed"
-       getfattr -d -m "^trusted" $testfile 2>/dev/null | grep "trusted.lov" ||
-               error "can't get trusted.lov from $testfile"
+       # check plain layout
+       check_102b_layout -S 65536 -i 1 -c $OSTCOUNT
 
-       local testfile2=${testfile}2
-       local value=$(getfattr -n trusted.lov $testfile 2>/dev/null |
-                       grep "trusted.lov" | sed -e 's/[^=]\+=//')
+       # and also check composite layout
+       check_102b_layout -E 1M -S 65536 -i 1 -c $OSTCOUNT -Eeof -S4M
 
-       $MCREATE $testfile2
-       setfattr -n trusted.lov -v $value $testfile2
-       local stripe_size=$($LFS getstripe -S $testfile2)
-       local stripe_count=$($LFS getstripe -c $testfile2)
-       [[ $stripe_size -eq 65536 ]] ||
-               error "stripe size $stripe_size != 65536"
-       [[ $stripe_count -eq $STRIPECOUNT ]] ||
-               error "stripe count $stripe_count != $STRIPECOUNT"
-       rm -f $DIR/$tfile
 }
-run_test 102b "getfattr/setfattr for trusted.lov EAs ============"
+run_test 102b "getfattr/setfattr for trusted.lov EAs"
 
 test_102c() {
        [ -z "$(which setfattr 2>/dev/null)" ] &&
@@ -11271,8 +11425,8 @@ test_121() { #bug #10589
 }
 run_test 121 "read cancel race ========="
 
-test_123a() { # was test 123, statahead(bug 11401)
-       [ $PARALLEL == "yes" ] && skip "skip parallel run"
+test_123a_base() { # was test 123, statahead(bug 11401)
+       local lsx="$1"
 
        SLOWOK=0
        if ! grep -q "processor.*: 1" /proc/cpuinfo; then
@@ -11284,76 +11438,120 @@ test_123a() { # was test 123, statahead(bug 11401)
        test_mkdir $DIR/$tdir
        NUMFREE=$(df -i -P $DIR | tail -n 1 | awk '{ print $4 }')
        [[ $NUMFREE -gt 100000 ]] && NUMFREE=100000 || NUMFREE=$((NUMFREE-1000))
-        MULT=10
-        for ((i=100, j=0; i<=$NUMFREE; j=$i, i=$((i * MULT)) )); do
-                createmany -o $DIR/$tdir/$tfile $j $((i - j))
-
-                max=`lctl get_param -n llite.*.statahead_max | head -n 1`
-                lctl set_param -n llite.*.statahead_max 0
-                lctl get_param llite.*.statahead_max
-                cancel_lru_locks mdc
-                cancel_lru_locks osc
-                stime=`date +%s`
-                time ls -l $DIR/$tdir | wc -l
-                etime=`date +%s`
-                delta=$((etime - stime))
-                log "ls $i files without statahead: $delta sec"
-                lctl set_param llite.*.statahead_max=$max
-
-                swrong=`lctl get_param -n llite.*.statahead_stats | grep "statahead wrong:" | awk '{print $3}'`
-                lctl get_param -n llite.*.statahead_max | grep '[0-9]'
-                cancel_lru_locks mdc
-                cancel_lru_locks osc
-                stime=`date +%s`
-                time ls -l $DIR/$tdir | wc -l
-                etime=`date +%s`
-                delta_sa=$((etime - stime))
-                log "ls $i files with statahead: $delta_sa sec"
-                lctl get_param -n llite.*.statahead_stats
-                ewrong=`lctl get_param -n llite.*.statahead_stats | grep "statahead wrong:" | awk '{print $3}'`
+       MULT=10
+       for ((i=100, j=0; i<=$NUMFREE; j=$i, i=$((i * MULT)) )); do
+               createmany -o $DIR/$tdir/$tfile $j $((i - j))
+
+               max=$(lctl get_param -n llite.*.statahead_max | head -n 1)
+               lctl set_param -n llite.*.statahead_max 0
+               lctl get_param llite.*.statahead_max
+               cancel_lru_locks mdc
+               cancel_lru_locks osc
+               stime=$(date +%s)
+               time $lsx $DIR/$tdir | wc -l
+               etime=$(date +%s)
+               delta=$((etime - stime))
+               log "$lsx $i files without statahead: $delta sec"
+               lctl set_param llite.*.statahead_max=$max
+
+               swrong=$(lctl get_param -n llite.*.statahead_stats |
+                       grep "statahead wrong:" | awk '{print $3}')
+               lctl get_param -n llite.*.statahead_max | grep '[0-9]'
+               cancel_lru_locks mdc
+               cancel_lru_locks osc
+               stime=$(date +%s)
+               time $lsx $DIR/$tdir | wc -l
+               etime=$(date +%s)
+               delta_sa=$((etime - stime))
+               log "$lsx $i files with statahead: $delta_sa sec"
+               lctl get_param -n llite.*.statahead_stats
+               ewrong=$(lctl get_param -n llite.*.statahead_stats |
+                       grep "statahead wrong:" | awk '{print $3}')
 
                [[ $swrong -lt $ewrong ]] &&
                        log "statahead was stopped, maybe too many locks held!"
                [[ $delta -eq 0 || $delta_sa -eq 0 ]] && continue
 
-                if [ $((delta_sa * 100)) -gt $((delta * 105)) -a $delta_sa -gt $((delta + 2)) ]; then
-                    max=`lctl get_param -n llite.*.statahead_max | head -n 1`
-                    lctl set_param -n llite.*.statahead_max 0
-                    lctl get_param llite.*.statahead_max
-                    cancel_lru_locks mdc
-                    cancel_lru_locks osc
-                    stime=`date +%s`
-                    time ls -l $DIR/$tdir | wc -l
-                    etime=`date +%s`
-                    delta=$((etime - stime))
-                    log "ls $i files again without statahead: $delta sec"
-                    lctl set_param llite.*.statahead_max=$max
-                    if [ $((delta_sa * 100)) -gt $((delta * 105)) -a $delta_sa -gt $((delta + 2)) ]; then
-                        if [  $SLOWOK -eq 0 ]; then
-                                error "ls $i files is slower with statahead!"
-                        else
-                                log "ls $i files is slower with statahead!"
-                        fi
-                        break
-                    fi
-                fi
+               if [ $((delta_sa * 100)) -gt $((delta * 105)) -a $delta_sa -gt $((delta + 2)) ]; then
+                       max=$(lctl get_param -n llite.*.statahead_max |
+                               head -n 1)
+                       lctl set_param -n llite.*.statahead_max 0
+                       lctl get_param llite.*.statahead_max
+                       cancel_lru_locks mdc
+                       cancel_lru_locks osc
+                       stime=$(date +%s)
+                       time $lsx $DIR/$tdir | wc -l
+                       etime=$(date +%s)
+                       delta=$((etime - stime))
+                       log "$lsx $i files again without statahead: $delta sec"
+                       lctl set_param llite.*.statahead_max=$max
+                       if [ $((delta_sa * 100 > delta * 105 && delta_sa > delta + 2)) ]; then
+                               if [  $SLOWOK -eq 0 ]; then
+                                       error "$lsx $i files is slower with statahead!"
+                               else
+                                       log "$lsx $i files is slower with statahead!"
+                               fi
+                               break
+                       fi
+               fi
 
-                [ $delta -gt 20 ] && break
-                [ $delta -gt 8 ] && MULT=$((50 / delta))
-                [ "$SLOW" = "no" -a $delta -gt 5 ] && break
-        done
-        log "ls done"
+               [ $delta -gt 20 ] && break
+               [ $delta -gt 8 ] && MULT=$((50 / delta))
+               [ "$SLOW" = "no" -a $delta -gt 5 ] && break
+       done
+       log "$lsx done"
 
-        stime=`date +%s`
-        rm -r $DIR/$tdir
-        sync
-        etime=`date +%s`
-        delta=$((etime - stime))
-        log "rm -r $DIR/$tdir/: $delta seconds"
-        log "rm done"
-        lctl get_param -n llite.*.statahead_stats
+       stime=$(date +%s)
+       rm -r $DIR/$tdir
+       sync
+       etime=$(date +%s)
+       delta=$((etime - stime))
+       log "rm -r $DIR/$tdir/: $delta seconds"
+       log "rm done"
+       lctl get_param -n llite.*.statahead_stats
+}
+
+test_123aa() {
+       [ $PARALLEL == "yes" ] && skip "skip parallel run"
+
+       test_123a_base "ls -l"
+}
+run_test 123aa "verify statahead work"
+
+test_123ab() {
+       [ $PARALLEL == "yes" ] && skip "skip parallel run"
+
+       statx_supported || skip_env "Test must be statx() syscall supported"
+
+       test_123a_base "$STATX -l"
+}
+run_test 123ab "verify statahead work by using statx"
+
+test_123ac() {
+       [ $PARALLEL == "yes" ] && skip "skip parallel run"
+
+       statx_supported || skip_env "Test must be statx() syscall supported"
+
+       local rpcs_before
+       local rpcs_after
+       local agl_before
+       local agl_after
+
+       cancel_lru_locks $OSC
+       rpcs_before=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
+       agl_before=$($LCTL get_param -n llite.*.statahead_stats |
+               awk '/agl.total:/ {print $3}')
+       test_123a_base "$STATX -c \"%n %i %A %h %u %g %W %X %Z\" -D"
+       test_123a_base "$STATX --cached=always -D"
+       agl_after=$($LCTL get_param -n llite.*.statahead_stats |
+               awk '/agl.total:/ {print $3}')
+       [ $agl_before -eq $agl_after ] ||
+               error "Should not trigger AGL thread - $agl_before:$agl_after"
+       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
+       [ $rpcs_after -eq $rpcs_before ] ||
+               error "$STATX should not send glimpse RPCs to $OSC"
 }
-run_test 123a "verify statahead work"
+run_test 123ac "verify statahead work by using statx without glimpse RPCs"
 
 test_123b () { # statahead(bug 15027)
        [ $PARALLEL == "yes" ] && skip "skip parallel run"
@@ -11878,7 +12076,7 @@ set_dir_limits () {
 check_mds_dmesg() {
        local facets=$(get_facets MDS)
        for facet in ${facets//,/ }; do
-               do_facet $facet "dmesg | tail -3 | grep -q $1" && return 0
+               do_facet $facet "dmesg | tail -3 | grep $1" && return 0
        done
        return 1
 }
@@ -11893,55 +12091,49 @@ test_129() {
        remote_mds_nodsh && skip "remote MDS with nodsh"
 
        local ENOSPC=28
-       local EFBIG=27
        local has_warning=false
 
        rm -rf $DIR/$tdir
        mkdir -p $DIR/$tdir
 
        # block size of mds1
-       local maxsize=$(($($LCTL get_param -n mdc.*MDT0000*.blocksize) * 5))
-       set_dir_limits $maxsize $maxsize
+       local maxsize=$(($($LCTL get_param -n mdc.*MDT0000*.blocksize) * 8))
+       set_dir_limits $maxsize $((maxsize * 6 / 8))
+       stack_trap "set_dir_limits 0 0"
+       stack_trap "unlinkmany $DIR/$tdir/file_base_ 2000 || true"
        local dirsize=$(stat -c%s "$DIR/$tdir")
        local nfiles=0
-       while [[ $dirsize -le $maxsize ]]; do
-               $MULTIOP $DIR/$tdir/file_base_$nfiles Oc
+       while (( $dirsize <= $maxsize )); do
+               $MCREATE $DIR/$tdir/file_base_$nfiles
                rc=$?
-               if ! $has_warning; then
-                       check_mds_dmesg '"is approaching"' && has_warning=true
-               fi
                # check two errors:
-               # ENOSPC for new ext4 max_dir_size (kernel commit df981d03ee)
-               # EFBIG for previous versions included in ldiskfs series
-               if [ $rc -eq $EFBIG ] || [ $rc -eq $ENOSPC ]; then
+               # ENOSPC for ext4 max_dir_size, which has been used since
+               # kernel v3.6-rc1-8-gdf981d03ee, lustre v2_4_50_0-79-gaed82035c0
+               if (( rc == ENOSPC )); then
                        set_dir_limits 0 0
-                       echo "return code $rc received as expected"
+                       echo "rc=$rc returned as expected after $nfiles files"
 
                        createmany -o $DIR/$tdir/file_extra_$nfiles. 5 ||
-                               error_exit "create failed w/o dir size limit"
+                               error "create failed w/o dir size limit"
 
-                       check_mds_dmesg '"has reached"' ||
-                               error_exit "reached message should be output"
-
-                       [ $has_warning = "false" ] &&
-                               error_exit "warning message should be output"
+                       # messages may be rate limited if test is run repeatedly
+                       check_mds_dmesg '"is approaching max"' ||
+                               echo "warning message should be output"
+                       check_mds_dmesg '"has reached max"' ||
+                               echo "reached message should be output"
 
                        dirsize=$(stat -c%s "$DIR/$tdir")
 
                        [[ $dirsize -ge $maxsize ]] && return 0
-                       error_exit "current dir size $dirsize, " \
-                                  "previous limit $maxsize"
-               elif [ $rc -ne 0 ]; then
-                       set_dir_limits 0 0
-                       error_exit "return $rc received instead of expected " \
-                                  "$EFBIG or $ENOSPC, files in dir $dirsize"
+                       error "dirsize $dirsize < $maxsize after $nfiles files"
+               elif (( rc != 0 )); then
+                       break
                fi
                nfiles=$((nfiles + 1))
                dirsize=$(stat -c%s "$DIR/$tdir")
        done
 
-       set_dir_limits 0 0
-       error "exceeded dir size limit $maxsize($MDSCOUNT) : $dirsize bytes"
+       error "rc=$rc, size=$dirsize/$maxsize, mdt=$MDSCOUNT, nfiles=$nfiles"
 }
 run_test 129 "test directory size limit ========================"
 
@@ -12668,38 +12860,21 @@ test_133e() {
 }
 run_test 133e "Verifying OST {read,write}_bytes nid stats ================="
 
-proc_regexp="/{proc,sys}/{fs,sys,kernel/debug}/{lustre,lnet}/"
-
-# Some versions of find (4.5.11, 4.5.14) included in CentOS 7.3-7.5 do
-# not honor the -ignore_readdir_race option correctly. So we call
-# error_ignore() rather than error() in these cases. See LU-11152.
-error_133() {
-       if (find --version; do_facet mds1 find --version) |
-               grep -q '\b4\.5\.1[1-4]\b'; then
-               error_ignore LU-11152 "$@"
-       else
-               error "$@"
-       fi
-}
-
 test_133f() {
-       # First without trusting modes.
-       local proc_dirs=$(eval \ls -d $proc_regexp 2>/dev/null)
-       echo "proc_dirs='$proc_dirs'"
-       [ -n "$proc_dirs" ] || error "no proc_dirs on $HOSTNAME"
-       find $proc_dirs -exec cat '{}' \; &> /dev/null
+       [[ $(lustre_version_code $facet) -ge $(version_code 2.7.65) ]] ||
+               skip "too old lustre for get_param -R ($facet_ver)"
 
-       # Second verifying readability.
+       # verifying readability.
        $LCTL get_param -R '*' &> /dev/null
 
        # Verifing writability with badarea_io.
-       find $proc_dirs \
-               -ignore_readdir_race \
-               -type f \
-               -not -name force_lbug \
-               -not -name changelog_mask \
-               -exec badarea_io '{}' \; ||
-                       error_133 "find $proc_dirs failed"
+       $LCTL list_param -FR '*' | grep '=' | tr -d = |
+               egrep -v 'force_lbug|changelog_mask' | xargs badarea_io ||
+               error "client badarea_io failed"
+
+       # remount the FS in case writes/reads /proc break the FS
+       cleanup || error "failed to unmount"
+       setup || error "failed to setup"
 }
 run_test 133f "Check reads/writes of client lustre proc files with bad area io"
 
@@ -12716,10 +12891,10 @@ test_133g() {
                        log "$facet: too old lustre for get_param -R"
                fi
                if [ $facet_ver -ge $(version_code 2.5.54) ]; then
-                       do_facet $facet "$LCTL list_param -R '*' | grep '=' |
-                               tr -d= | egrep -v 'force_lbug|changelog_mask' |
+                       do_facet $facet "$LCTL list_param -FR '*' | grep '=' |
+                               tr -d = | egrep -v 'force_lbug|changelog_mask' |
                                xargs badarea_io" ||
-                                       error_133 "$facet badarea_io failed"
+                                       error "$facet badarea_io failed"
                else
                        skip_noexit "$facet: too old lustre for get_param -R"
                fi
@@ -12728,7 +12903,6 @@ test_133g() {
        # remount the FS in case writes/reads /proc break the FS
        cleanup || error "failed to unmount"
        setup || error "failed to setup"
-       true
 }
 run_test 133g "Check reads/writes of server lustre proc files with bad area io"
 
@@ -12741,22 +12915,19 @@ test_133h() {
        local facet
 
        for facet in client mds1 ost1; do
-               local facet_proc_dirs=$(do_facet $facet \
-                                       \\\ls -d $proc_regexp 2> /dev/null)
-               [ -z "$facet_proc_dirs" ] && error "no proc_dirs on $facet"
-               echo "${facet}_proc_dirs='$facet_proc_dirs'"
                # Get the list of files that are missing the terminating newline
-               local missing=($(do_facet $facet \
-                       find ${facet_proc_dirs} -type f \|              \
-                               while read F\; do                       \
-                                       awk -v FS='\v' -v RS='\v\v'     \
-                                       "'END { if(NR>0 &&              \
-                                       \\\$NF !~ /.*\\\n\$/)           \
-                                               print FILENAME}'"       \
-                                       '\$F'\;                         \
-                               done 2>/dev/null))
-               [ ${#missing[*]} -eq 0 ] ||
-                       error "files do not end with newline: ${missing[*]}"
+               #local missing=($(do_facet $facet \
+               local plist=$(do_facet $facet
+                       $LCTL list_param -FR '*' | grep '=' | tr -d =)
+               local ent
+               for ent in $plist; do
+                       local missing=$(do_facet $facet $LCTL get_param $ent \|\
+                               awk -v FS='\v' -v RS='\v\v' \
+                               "'END { if(NR>0 && \\\$NF !~ /.*\\\n\$/) \
+                                       print FILENAME}'" 2>/dev/null)
+                       [ -z $missing ] ||
+                               error "files do not end with newline: $missing"
+               done
        done
 }
 run_test 133h "Proc files should end with newlines"
@@ -12945,7 +13116,7 @@ test_140() { #bug-17379
 }
 run_test 140 "Check reasonable stack depth (shouldn't LBUG) ===="
 
-test_150() {
+test_150a() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run"
 
        local TF="$TMP/$tfile"
@@ -12976,7 +13147,60 @@ test_150() {
        rm -f $TF
        true
 }
-run_test 150 "truncate/append tests"
+run_test 150a "truncate/append tests"
+
+test_150b() {
+       [ "$ost1_FSTYPE" != ldiskfs ] && skip "non-ldiskfs backend"
+       [ $OST1_VERSION -lt $(version_code 2.13.50) ] &&
+               skip "Need OST version at least 2.13.53"
+       touch $DIR/$tfile
+       check_fallocate $DIR/$tfile || error "fallocate failed"
+}
+run_test 150b "Verify fallocate (prealloc) functionality"
+
+test_150c() {
+       local bytes
+       local want
+
+       [ "$ost1_FSTYPE" != ldiskfs ] && skip "non-ldiskfs backend"
+       [ $OST1_VERSION -lt $(version_code 2.13.50) ] &&
+               skip "Need OST version at least 2.13.53"
+
+       $LFS setstripe -c $OSTCOUNT -S1M $DIR/$tdir || error "setstripe failed"
+       fallocate -l ${OSTCOUNT}m $DIR/$tdir || error "fallocate failed"
+       sync; sync_all_data
+       cancel_lru_locks $OSC
+       sleep 5
+       bytes=$(($(stat -c '%b * %B' $DIR/$tdir)))
+       want=$((OSTCOUNT * 1048576))
+
+       # Must allocate all requested space, not more than 5% extra
+       (( $bytes >= $want && $bytes < $want * 105 / 100 )) ||
+               error "bytes $bytes is not $want"
+}
+run_test 150c "Verify fallocate Size and Blocks"
+
+test_150d() {
+       local bytes
+       local want
+
+       [ "$ost1_FSTYPE" != ldiskfs ] && skip "non-ldiskfs backend"
+       [ $OST1_VERSION -lt $(version_code 2.13.50) ] &&
+               skip "Need OST version at least 2.13.53"
+
+       $LFS setstripe -c $OSTCOUNT -S1M $DIR/$tdir || error "setstripe failed"
+       fallocate -o 1G -l ${OSTCOUNT}m $DIR/$tdir || error "fallocate failed"
+       sync; sync_all_data
+       cancel_lru_locks $OSC
+       sleep 5
+       bytes=$(($(stat -c '%b * %B' $DIR/$tdir)))
+       want=$((OSTCOUNT * 1048576))
+
+       # Must allocate all requested space, not more than 5% extra
+       (( $bytes >= $want && $bytes < $want * 105 / 100 )) ||
+               error "bytes $bytes is not $want"
+}
+run_test 150d "Verify fallocate Size and Blocks - Non zero start"
 
 #LU-2902 roc_hit was not able to read all values from lproc
 function roc_hit_init() {
@@ -14933,6 +15157,233 @@ test_162c() {
 }
 run_test 162c "fid2path works with paths 100 or more directories deep"
 
+oalr_event_count() {
+       local event="${1}"
+       local trace="${2}"
+
+       awk -v name="${FSNAME}-OST0000" \
+           -v event="${event}" \
+           '$1 == "TRACE" && $2 == event && $3 == name' \
+           "${trace}" |
+       wc -l
+}
+
+oalr_expect_event_count() {
+       local event="${1}"
+       local trace="${2}"
+       local expect="${3}"
+       local count
+
+       count=$(oalr_event_count "${event}" "${trace}")
+       if ((count == expect)); then
+               return 0
+       fi
+
+       error_noexit "${event} event count was '${count}', expected ${expect}"
+       cat "${trace}" >&2
+       exit 1
+}
+
+cleanup_165() {
+       do_facet ost1 killall --quiet -KILL ofd_access_log_reader || true
+       stop ost1
+       start ost1 "$(ostdevname 1)" $OST_MOUNT_OPTS
+}
+
+setup_165() {
+       sync # Flush previous IOs so we can count log entries.
+       do_facet ost1 $LCTL set_param "obdfilter.${FSNAME}-OST0000.access_log_size=4096"
+       stack_trap cleanup_165 EXIT
+}
+
+test_165a() {
+       local trace="/tmp/${tfile}.trace"
+       local rc
+       local count
+
+       do_facet ost1 ofd_access_log_reader --debug=- --trace=- > "${trace}" &
+       setup_165
+       sleep 5
+
+       do_facet ost1 ofd_access_log_reader --list
+       stop ost1
+
+       do_facet ost1 killall -TERM ofd_access_log_reader
+       wait
+       rc=$?
+
+       if ((rc != 0)); then
+               error "ofd_access_log_reader exited with rc = '${rc}'"
+       fi
+
+       # Parse trace file for discovery events:
+       oalr_expect_event_count alr_log_add "${trace}" 1
+       oalr_expect_event_count alr_log_eof "${trace}" 1
+       oalr_expect_event_count alr_log_free "${trace}" 1
+}
+run_test 165a "ofd access log discovery"
+
+test_165b() {
+       local trace="/tmp/${tfile}.trace"
+       local file="${DIR}/${tfile}"
+       local pfid1
+       local pfid2
+       local -a entry
+       local rc
+       local count
+       local size
+       local flags
+
+       setup_165
+
+       lfs setstripe -c 1 -i 0 "${file}"
+       $MULTIOP "${file}" oO_CREAT:O_DIRECT:O_WRONLY:w1048576c || error "cannot create '${file}'"
+       do_facet ost1 ofd_access_log_reader --list
+
+       do_facet ost1 ofd_access_log_reader --debug=- --trace=- > "${trace}" &
+       sleep 5
+       do_facet ost1 killall -TERM ofd_access_log_reader
+       wait
+       rc=$?
+
+       if ((rc != 0)); then
+               error "ofd_access_log_reader exited with rc = '${rc}'"
+       fi
+
+       oalr_expect_event_count alr_log_entry "${trace}" 1
+
+       pfid1=$($LFS path2fid "${file}")
+
+       # 1     2             3   4    5     6   7    8    9     10
+       # TRACE alr_log_entry OST PFID BEGIN END TIME SIZE COUNT FLAGS
+       entry=( - $(awk -v pfid="${pfid}" '$1 == "TRACE" && $2 == "alr_log_entry"' "${trace}" ) )
+
+       echo "entry = '${entry[*]}'" >&2
+
+       pfid2=${entry[4]}
+       if [[ "${pfid1}" != "${pfid2}" ]]; then
+               error "entry '${entry[*]}' has invalid PFID '${pfid2}', expected ${pfid1}"
+       fi
+
+       size=${entry[8]}
+       if ((size != 1048576)); then
+               error "entry '${entry[*]}' has invalid io size '${size}', expected 1048576"
+       fi
+
+       flags=${entry[10]}
+       if [[ "${flags}" != "w" ]]; then
+               error "entry '${entry[*]}' has invalid io flags '${flags}', expected 'w'"
+       fi
+
+       do_facet ost1 ofd_access_log_reader --debug=- --trace=- > "${trace}" &
+       $MULTIOP "${file}" oO_CREAT:O_DIRECT:O_RDONLY:r524288c || error "cannot read '${file}'"
+       sleep 5
+       do_facet ost1 killall -TERM ofd_access_log_reader
+       wait
+       rc=$?
+
+       if ((rc != 0)); then
+               error "ofd_access_log_reader exited with rc = '${rc}'"
+       fi
+
+       oalr_expect_event_count alr_log_entry "${trace}" 1
+
+       entry=( - $(awk -v pfid="${pfid}" '$1 == "TRACE" && $2 == "alr_log_entry"' "${trace}" ) )
+       echo "entry = '${entry[*]}'" >&2
+
+       pfid2=${entry[4]}
+       if [[ "${pfid1}" != "${pfid2}" ]]; then
+               error "entry '${entry[*]}' has invalid PFID '${pfid2}', expected ${pfid1}"
+       fi
+
+       size=${entry[8]}
+       if ((size != 524288)); then
+               error "entry '${entry[*]}' has invalid io size '${size}', 524288"
+       fi
+
+       flags=${entry[10]}
+       if [[ "${flags}" != "r" ]]; then
+               error "entry '${entry[*]}' has invalid io flags '${flags}', expected 'r'"
+       fi
+}
+run_test 165b "ofd access log entries are produced and consumed"
+
+test_165c() {
+       local file="${DIR}/${tdir}/${tfile}"
+       test_mkdir "${DIR}/${tdir}"
+
+       setup_165
+
+       lfs setstripe -c 1 -i 0 "${DIR}/${tdir}"
+
+       # 4096 / 64 = 64. Create twice as many entries.
+       for ((i = 0; i < 128; i++)); do
+               $MULTIOP "${file}-${i}" oO_CREAT:O_WRONLY:w512c || error "cannot create file"
+       done
+
+       sync
+       do_facet ost1 ofd_access_log_reader --list
+       unlinkmany  "${file}-%d" 128
+}
+run_test 165c "full ofd access logs do not block IOs"
+
+oal_peek_entry_count() {
+       do_facet ost1 ofd_access_log_reader --list | awk '$1 == "_entry_count:" { print $2; }'
+}
+
+oal_expect_entry_count() {
+       local entry_count=$(oal_peek_entry_count)
+       local expect="$1"
+
+       if ((entry_count == expect)); then
+               return 0
+       fi
+
+       error_noexit "bad entry count, got ${entry_count}, expected ${expect}"
+       do_facet ost1 ofd_access_log_reader --list >&2
+       exit 1
+}
+
+test_165d() {
+       local trace="/tmp/${tfile}.trace"
+       local file="${DIR}/${tdir}/${tfile}"
+       local param="obdfilter.${FSNAME}-OST0000.access_log_mask"
+       local entry_count
+       test_mkdir "${DIR}/${tdir}"
+
+       setup_165
+       lfs setstripe -c 1 -i 0 "${file}"
+
+       do_facet ost1 lctl set_param "${param}=rw"
+       $MULTIOP "${file}" oO_CREAT:O_DIRECT:O_WRONLY:w1048576c || error "cannot create '${file}'"
+       oal_expect_entry_count 1
+
+       $MULTIOP "${file}" oO_CREAT:O_DIRECT:O_RDONLY:r1048576c || error "cannot read '${file}'"
+       oal_expect_entry_count 2
+
+       do_facet ost1 lctl set_param "${param}=r"
+       $MULTIOP "${file}" oO_CREAT:O_DIRECT:O_WRONLY:w1048576c || error "cannot create '${file}'"
+       oal_expect_entry_count 2
+
+       $MULTIOP "${file}" oO_CREAT:O_DIRECT:O_RDONLY:r1048576c || error "cannot read '${file}'"
+       oal_expect_entry_count 3
+
+       do_facet ost1 lctl set_param "${param}=w"
+       $MULTIOP "${file}" oO_CREAT:O_DIRECT:O_WRONLY:w1048576c || error "cannot create '${file}'"
+       oal_expect_entry_count 4
+
+       $MULTIOP "${file}" oO_CREAT:O_DIRECT:O_RDONLY:r1048576c || error "cannot read '${file}'"
+       oal_expect_entry_count 4
+
+       do_facet ost1 lctl set_param "${param}=0"
+       $MULTIOP "${file}" oO_CREAT:O_DIRECT:O_WRONLY:w1048576c || error "cannot create '${file}'"
+       oal_expect_entry_count 4
+
+       $MULTIOP "${file}" oO_CREAT:O_DIRECT:O_RDONLY:r1048576c || error "cannot read '${file}'"
+       oal_expect_entry_count 4
+}
+run_test 165d "ofd_access_log mask works"
+
 test_169() {
        # do directio so as not to populate the page cache
        log "creating a 10 Mb file"
@@ -17909,6 +18360,38 @@ test_247e() {
 }
 run_test 247e "mount .. as fileset"
 
+test_247f() {
+       [ $MDSCOUNT -lt 2 ] && skip_env "needs >= 2 MDTs"
+       [ $MDS1_VERSION -lt $(version_code 2.13.52) ] &&
+               skip "Need at least version 2.13.52"
+       lctl get_param -n mdc.$FSNAME-MDT0000*.import |
+               grep -q subtree ||
+               skip "Fileset feature is not supported"
+
+       mkdir $DIR/$tdir || error "mkdir $tdir failed"
+       $LFS mkdir -i $((MDSCOUNT - 1)) $DIR/$tdir/remote ||
+               error "mkdir remote failed"
+       mkdir $DIR/$tdir/remote/subdir || error "mkdir remote/subdir failed"
+       $LFS mkdir -c $MDSCOUNT $DIR/$tdir/striped ||
+               error "mkdir striped failed"
+       mkdir $DIR/$tdir/striped/subdir || error "mkdir striped/subdir failed"
+
+       local submount=${MOUNT}_$tdir
+
+       mkdir -p $submount || error "mkdir $submount failed"
+
+       local dir
+       local fileset=$FILESET
+
+       for dir in $tdir/remote $tdir/remote/subdir \
+                  $tdir/striped $tdir/striped/subdir $tdir/striped/. ; do
+               FILESET="$fileset/$dir" mount_client $submount ||
+                       error "mount $dir failed"
+               umount_client $submount
+       done
+}
+run_test 247f "mount striped or remote directory as fileset"
+
 test_248a() {
        local fast_read_sav=$($LCTL get_param -n llite.*.fast_read 2>/dev/null)
        [ -z "$fast_read_sav" ] && skip "no fast read support"
@@ -19063,6 +19546,71 @@ test_270f() {
 }
 run_test 270f "DoM: maximum DoM stripe size checks"
 
+test_270g() {
+       [ $MDS1_VERSION -ge $(version_code 2.13.52) ] ||
+               skip "Need MDS version at least 2.13.52"
+       local dom=$DIR/$tdir/$tfile
+
+       $LFS mkdir -i 0 -c 1 $DIR/$tdir
+       local lodname=${FSNAME}-MDT0000-mdtlov
+
+       local save="$TMP/$TESTSUITE-$TESTNAME.parameters"
+       save_lustre_params mds1 "lod.${lodname}.dom_stripesize_max_kb" > $save
+       save_lustre_params mds1 "lod.${lodname}.dom_threshold_free_mb" >> $save
+       stack_trap "restore_lustre_params < $save; rm -f $save" EXIT
+
+       local dom_limit=1024
+       local dom_threshold="50%"
+
+       $LFS setstripe -d $DIR/$tdir
+       $LFS setstripe -E ${dom_limit}K -L mdt $DIR/$tdir ||
+               error "Can't set directory default striping"
+
+       do_facet mds1 $LCTL set_param -n \
+                               lod.${lodname}.dom_stripesize_max_kb=$dom_limit
+       # set 0 threshold and create DOM file to change tunable stripesize
+       do_facet mds1 $LCTL set_param -n lod.${lodname}.dom_threshold_free_mb=0
+       $LFS setstripe -E ${dom_limit}K -L mdt -E -1 $dom ||
+               error "Failed to create $dom file"
+       # now tunable dom_cur_stripesize should reach maximum
+       local dom_current=$(do_facet mds1 $LCTL get_param -n \
+                                       lod.${lodname}.dom_stripesize_cur_kb)
+       [[ $dom_current == $dom_limit ]] ||
+               error "Current DOM stripesize is not maximum"
+       rm $dom
+
+       # set threshold for further tests
+       do_facet mds1 $LCTL set_param -n \
+                       lod.${lodname}.dom_threshold_free_mb=$dom_threshold
+       echo "DOM threshold is $dom_threshold free space"
+       local dom_def
+       local dom_set
+       # Spoof bfree to exceed threshold
+       #define OBD_FAIL_MDS_STATFS_SPOOF   0x168
+       do_facet mds1 $LCTL set_param -n fail_loc=0x0168
+       for spfree in 40 20 0 15 30 55; do
+               do_facet mds1 $LCTL set_param -n fail_val=$spfree
+               $LFS setstripe -E ${dom_limit}K -L mdt -E -1 $dom ||
+                       error "Failed to create $dom file"
+               dom_def=$(do_facet mds1 $LCTL get_param -n \
+                                       lod.${lodname}.dom_stripesize_cur_kb)
+               echo "Free space: ${spfree}%, default DOM stripe: ${dom_def}K"
+               [[ $dom_def != $dom_current ]] ||
+                       error "Default stripe size was not changed"
+               if [[ $spfree > 0 ]] ; then
+                       dom_set=$($LFS getstripe -S $dom)
+                       [[ $dom_set == $((dom_def * 1024)) ]] ||
+                               error "DOM component size is still old"
+               else
+                       [[ $($LFS getstripe -L $dom) != "mdt" ]] ||
+                               error "DoM component is set with no free space"
+               fi
+               rm $dom
+               dom_current=$dom_def
+       done
+}
+run_test 270g "DoM: default DoM stripe size depends on free space"
+
 test_271a() {
        [ $MDS1_VERSION -lt $(version_code 2.10.55) ] &&
                skip "Need MDS version at least 2.10.55"
@@ -21067,6 +21615,7 @@ test_401a() { #LU-7437
        #count the number of parameters by "list_param -R"
        local params=$($LCTL list_param -R '*' 2>/dev/null | wc -l)
        #count the number of parameters by listing proc files
+       local proc_regexp="/{proc,sys}/{fs,sys,kernel/debug}/{lustre,lnet}/"
        local proc_dirs=$(eval \ls -d $proc_regexp 2>/dev/null)
        echo "proc_dirs='$proc_dirs'"
        [ -n "$proc_dirs" ] || error "no proc_dirs on $HOSTNAME"
@@ -22704,7 +23253,8 @@ test_805() {
        do_facet $SINGLEMDS zfs set quota=$(((usedkb+freekb)*1024)) $fsset
        trap cleanup_805 EXIT
        mkdir $DIR/$tdir
-       $LFS setstripe -E 1M -L mdt $DIR/$tdir || error "DoM not working"
+       $LFS setstripe -E 1M -c2 -E 4M -c2 -E -1 -c2 $DIR/$tdir ||
+               error "Can't set PFL layout"
        createmany -m $DIR/$tdir/f- 1000000 && error "ENOSPC wasn't met"
        rm -rf $DIR/$tdir || error "not able to remove"
        do_facet $SINGLEMDS zfs set quota=$old $fsset
@@ -22856,7 +23406,7 @@ test_807() {
                error "truncate $tdir/trunc failed"
 
        local bs=1048576
-       dd if=/dev/zero of=$DIR/$tdir/single_dd bs=$bs count=1 ||
+       dd if=/dev/zero of=$DIR/$tdir/single_dd bs=$bs count=1 conv=fsync ||
                error "write $tfile failed"
 
        # multi-client wirtes
@@ -22877,7 +23427,8 @@ test_807() {
                wait ${pids[$i]}
        done
 
-       sleep 5
+       do_rpc_nodes "$CLIENTS" cancel_lru_locks osc
+       do_nodes "$CLIENTS" "sync ; sleep 5 ; sync"
        $LSOM_SYNC -u $cl_user -m $FSNAME-MDT0000 $MOUNT
        check_lsom_data $DIR/$tdir/trunc
        check_lsom_data $DIR/$tdir/single_dd